#
# Describe all the keys
#

# Add special Keys; taken from ncurses.h
$KeyCode{"KEY_BREAK"}=       0401;           # Break key (unreliable) */
$KeyCode{"KEY_DOWN"}=        0402;           # Down-arrow */
$KeyCode{"KEY_UP"}=          0403;           # Up-arrow */
$KeyCode{"KEY_LEFT"}=        0404;           # Left-arrow */
$KeyCode{"KEY_RIGHT"}=       0405;           # Right-arrow */
$KeyCode{"KEY_HOME"}=        0406;           # Home key (upward+left arrow) */
$KeyCode{"KEY_BACKSPACE"}=   0407;           # Backspace (unreliable) */
$KeyCode{"KEY_F0"}=          0410;           # Function keys.  Space for 64 */
$KeyCode{"KEY_F1"}=          0411;
$KeyCode{"KEY_F2"}=          0412;
$KeyCode{"KEY_F3"}=          0413;
$KeyCode{"KEY_F4"}=          0414;
$KeyCode{"KEY_F5"}=          0415;
$KeyCode{"KEY_F6"}=          0416;
$KeyCode{"KEY_F7"}=          0417;
$KeyCode{"KEY_F8"}=          0420;
$KeyCode{"KEY_F9"}=          0421;
$KeyCode{"KEY_F10"}=         0422;
$KeyCode{"KEY_F11"}=         0423;
$KeyCode{"KEY_F12"}=         0424;
$KeyCode{"KEY_F13"}=         0425;
$KeyCode{"KEY_F14"}=         0426;
$KeyCode{"KEY_F15"}=         0427;
$KeyCode{"KEY_F16"}=         0430;
$KeyCode{"KEY_F17"}=         0431;
$KeyCode{"KEY_F18"}=         0432;
$KeyCode{"KEY_F19"}=         0433;
$KeyCode{"KEY_F20"}=         0434;
$KeyCode{"KEY_F21"}=         0435;
$KeyCode{"KEY_F22"}=         0436;
$KeyCode{"KEY_F23"}=         0437;
$KeyCode{"KEY_F24"}=         0440;
$KeyCode{"KEY_F25"}=         0441;
$KeyCode{"KEY_F26"}=         0442;
$KeyCode{"KEY_F27"}=         0443;
$KeyCode{"KEY_F28"}=         0444;
$KeyCode{"KEY_F29"}=         0445;
$KeyCode{"KEY_F30"}=         0446;
$KeyCode{"KEY_F31"}=         0447;
$KeyCode{"KEY_F32"}=         0450;
$KeyCode{"KEY_F33"}=         0451;
$KeyCode{"KEY_F34"}=         0452;
$KeyCode{"KEY_F35"}=         0453;
$KeyCode{"KEY_F36"}=         0454;
$KeyCode{"KEY_F37"}=         0455;
$KeyCode{"KEY_F38"}=         0456;
$KeyCode{"KEY_F39"}=         0457;
$KeyCode{"KEY_F40"}=         0460;
$KeyCode{"KEY_F41"}=         0461;
$KeyCode{"KEY_F42"}=         0462;
$KeyCode{"KEY_F43"}=         0463;
$KeyCode{"KEY_F44"}=         0464;
$KeyCode{"KEY_F45"}=         0465;
$KeyCode{"KEY_F46"}=         0466;
$KeyCode{"KEY_F47"}=         0467;
$KeyCode{"KEY_F48"}=         0470;
$KeyCode{"KEY_F49"}=         0471;
$KeyCode{"KEY_F50"}=         0472;
$KeyCode{"KEY_F51"}=         0473;
$KeyCode{"KEY_F52"}=         0474;
$KeyCode{"KEY_F53"}=         0475;
$KeyCode{"KEY_F54"}=         0576;
$KeyCode{"KEY_F55"}=         0477;
$KeyCode{"KEY_F56"}=         0500;
$KeyCode{"KEY_F57"}=         0501;
$KeyCode{"KEY_F58"}=         0502;
$KeyCode{"KEY_F59"}=         0503;
$KeyCode{"KEY_F60"}=         0504;
$KeyCode{"KEY_F61"}=         0505;
$KeyCode{"KEY_F62"}=         0506;
$KeyCode{"KEY_F63"}=         0507;
$KeyCode{"KEY_DL"}=          0510;           # Delete line */
$KeyCode{"KEY_IL"}=          0511;           # Insert line */
$KeyCode{"KEY_DC"}=          0512;           # Delete character */
$KeyCode{"KEY_IC"}=          0513;           # Insert char or enter insert mode */
$KeyCode{"KEY_EIC"}=         0514;           # Exit insert char mode */
$KeyCode{"KEY_CLEAR"}=       0515;           # Clear screen */
$KeyCode{"KEY_EOS"}=         0516;           # Clear to end of screen */
$KeyCode{"KEY_EOL"}=         0517;           # Clear to end of line */
$KeyCode{"KEY_SF"}=          0520;           # Scroll 1 line forward */
$KeyCode{"KEY_SR"}=          0521;           # Scroll 1 line backward (reverse) */
$KeyCode{"KEY_NPAGE"}=       0522;           # Next page */
$KeyCode{"KEY_PPAGE"}=       0523;           # Previous page */
$KeyCode{"KEY_STAB"}=        0524;           # Set tab */
$KeyCode{"KEY_CTAB"}=        0525;           # Clear tab */
$KeyCode{"KEY_CATAB"}=       0526;           # Clear all tabs */
$KeyCode{"KEY_ENTER"}=       0527;           # Enter or send (unreliable) */
$KeyCode{"KEY_SRESET"}=      0530;           # Soft (partial) reset (unreliable) */
$KeyCode{"KEY_RESET"}=       0531;           # Reset or hard reset (unreliable) */
$KeyCode{"KEY_PRINT"}=       0532;           # Print */
$KeyCode{"KEY_LL"}=          0533;           # Home down or bottom (lower left) */
$KeyCode{"KEY_A1"}=          0534;           # Upper left of keypad */
$KeyCode{"KEY_A3"}=          0535;           # Upper right of keypad */
$KeyCode{"KEY_B2"}=          0536;           # Center of keypad */
$KeyCode{"KEY_C1"}=          0537;           # Lower left of keypad */
$KeyCode{"KEY_C3"}=          0540;           # Lower right of keypad */
$KeyCode{"KEY_BTAB"}=        0541;           # Back tab */
$KeyCode{"KEY_BEG"}=         0542;           # Beg (beginning) */
$KeyCode{"KEY_CANCEL"}=      0543;           # Cancel */
$KeyCode{"KEY_CLOSE"}=       0544;           # Close */
$KeyCode{"KEY_COMMAND"}=     0545;           # Cmd (command) */
$KeyCode{"KEY_COPY"}=        0546;           # Copy */
$KeyCode{"KEY_CREATE"}=      0547;           # Create */
$KeyCode{"KEY_END"}=         0550;           # End */
$KeyCode{"KEY_EXIT"}=        0551;           # Exit */
$KeyCode{"KEY_FIND"}=        0552;           # Find */
$KeyCode{"KEY_HELP"}=        0553;           # Help */
$KeyCode{"KEY_MARK"}=        0554;           # Mark */
$KeyCode{"KEY_MESSAGE"}=     0555;           # Message */
$KeyCode{"KEY_MOVE"}=        0556;           # Move */
$KeyCode{"KEY_NEXT"}=        0557;           # Next */
$KeyCode{"KEY_OPEN"}=        0560;           # Open */
$KeyCode{"KEY_OPTIONS"}=     0561;           # Options */
$KeyCode{"KEY_PREVIOUS"}=    0562;           # Prev (previous) */
$KeyCode{"KEY_REDO"}=        0563;           # Redo */
$KeyCode{"KEY_REFERENCE"}=   0564;           # Ref (reference) */
$KeyCode{"KEY_REFRESH"}=     0565;           # Refresh */
$KeyCode{"KEY_REPLACE"}=     0566;           # Replace */
$KeyCode{"KEY_RESTART"}=     0567;           # Restart */
$KeyCode{"KEY_RESUME"}=      0570;           # Resume */
$KeyCode{"KEY_SAVE"}=        0571;           # Save */
$KeyCode{"KEY_SBEG"}=        0572;           # Shifted Beg (beginning) */
$KeyCode{"KEY_SCANCEL"}=     0573;           # Shifted Cancel */
$KeyCode{"KEY_SCOMMAND"}=    0574;           # Shifted Command */
$KeyCode{"KEY_SCOPY"}=       0575;           # Shifted Copy */
$KeyCode{"KEY_SCREATE"}=     0576;           # Shifted Create */
$KeyCode{"KEY_SDC"}=         0577;           # Shifted Delete char */
$KeyCode{"KEY_SDL"}=         0600;           # Shifted Delete line */
$KeyCode{"KEY_SELECT"}=      0601;           # Select */
$KeyCode{"KEY_SEND"}=        0602;           # Shifted End */
$KeyCode{"KEY_SEOL"}=        0603;           # Shifted Clear line */
$KeyCode{"KEY_SEXIT"}=       0604;           # Shifted Dxit */
$KeyCode{"KEY_SFIND"}=       0605;           # Shifted Find */
$KeyCode{"KEY_SHELP"}=       0606;           # Shifted Help */
$KeyCode{"KEY_SHOME"}=       0607;           # Shifted Home */
$KeyCode{"KEY_SIC"}=         0610;           # Shifted Input */
$KeyCode{"KEY_SLEFT"}=       0611;           # Shifted Left arrow */
$KeyCode{"KEY_SMESSAGE"}=    0612;           # Shifted Message */
$KeyCode{"KEY_SMOVE"}=       0613;           # Shifted Move */
$KeyCode{"KEY_SNEXT"}=       0614;           # Shifted Next */
$KeyCode{"KEY_SOPTIONS"}=    0615;           # Shifted Options */
$KeyCode{"KEY_SPREVIOUS"}=   0616;           # Shifted Prev */
$KeyCode{"KEY_SPRINT"}=      0617;           # Shifted Print */
$KeyCode{"KEY_SREDO"}=       0620;           # Shifted Redo */
$KeyCode{"KEY_SREPLACE"}=    0621;           # Shifted Replace */
$KeyCode{"KEY_SRIGHT"}=      0622;           # Shifted Right arrow */
$KeyCode{"KEY_SRSUME"}=      0623;           # Shifted Resume */
$KeyCode{"KEY_SSAVE"}=       0624;           # Shifted Save */
$KeyCode{"KEY_SSUSPEND"}=    0625;           # Shifted Suspend */
$KeyCode{"KEY_SUNDO"}=       0626;           # Shifted Undo */
$KeyCode{"KEY_SUSPEND"}=     0627;           # Suspend */
$KeyCode{"KEY_UNDO"}=        0630;           # Undo */
$KeyCode{"KEY_MOUSE"}=       0631;           # Mouse event has occurred */
$KeyCode{"KEY_RESIZE"}=      0632;           # Terminal resize event */

# Add the ascii keys
for($i=0;$i<128;$i++){$KeyCode{chr($i)}=$i;}

# Add some better descriptions
foreach $c (a..z) { # add all the control's (^x etc)
	$KeyCode{"^".$c} = ord($c) - (ord('a')-1);
	$KeyCode{"^".uc($c)} = ord($c) - (ord('a')-1);
}
$KeyCode{"NUL"} = 0;
$KeyCode{"SOH"} = 1;
$KeyCode{"STX"} = 2;
$KeyCode{"ETX"} = 3;
$KeyCode{"EOT"} = 4;
$KeyCode{"ENQ"} = 5;
$KeyCode{"ACK"} = 6;
$KeyCode{"BEL"} = 7;
$KeyCode{"BS"} = 8;
$KeyCode{"HT"} = 9;
$KeyCode{"TAB"} = 9;
$KeyCode{"LF"} = 10;
$KeyCode{"VT"} = 11;
$KeyCode{"FF"} = 12;
$KeyCode{"CR"} = 13;
$KeyCode{"SO"} = 14;
$KeyCode{"SI"} = 15;
$KeyCode{"DLE"} = 16;
$KeyCode{"DC1"} = 17;
$KeyCode{"DC2"} = 18;
$KeyCode{"DC3"} = 19;
$KeyCode{"DC4"} = 20;
$KeyCode{"NAK"} = 21;
$KeyCode{"SYN"} = 22;
$KeyCode{"ETB"} = 23;
$KeyCode{"CAN"} = 24;
$KeyCode{"EM"} = 25;
$KeyCode{"SUB"} = 26;
$KeyCode{"ESC"} = 27;
$KeyCode{"FS"} = 28;
$KeyCode{"GS"} = 29;
$KeyCode{"RS"} = 30;
$KeyCode{"US"} = 31;
$KeyCode{"SPACE"} = 32;
$KeyCode{"DEL"} = 127;

# Invert the hash for reverse lookups
foreach $keyd (keys %KeyCode) {
	if($keyd =~ /^\^/ ||
	   !$KeyDesc{$KeyCode{$keyd}})
	{
		$KeyDesc{$KeyCode{$keyd}} = $keyd;
	}
}

#foreach $keyd (sort values %KeyDesc){ print "$keyd\n";}
#foreach $keyd (sort keys %KeyCode){ print "$keyd\n";}

1;
